//  CalculatorBrain.m
//  Calculator
//
//  Created by Nathaniel Hillard on 8/20/11.
//  Copyright 2011 Loqate, Inc. All rights reserved.
//

#import "CalculatorBrain.h"

@implementation CalculatorBrain

@synthesize operand;
@synthesize storedValue;
@synthesize waitingOperand;

@synthesize isDegrees;
@synthesize isPending;

- (void) performWaitingOperation
{
    if ([@"+" isEqual:waitingOperation]){
        self.operand= self.waitingOperand+self.operand;
    } else if ([@"-" isEqual:waitingOperation]){
        self.operand = self.waitingOperand-self.operand;
    }else if ([@"*" isEqual:waitingOperation]){
        self.operand = self.waitingOperand*self.operand;
    }else if ([@"/" isEqual:waitingOperation]){
        if(self.operand){
             self.operand = self.waitingOperand/self.operand;
        }
    }
}


-(double)performOperation:(NSString *) operation
{
    if ([operation isEqual:@"sqrt"]) {
        self.operand=sqrt(self.operand);
        self.isPending=NO;
    }else if([@"+/-" isEqual:operation]){
        self.operand = - self.operand;
        self.isPending=NO;
    } else if([@"ms" isEqual:operation]){
        self.storedValue = self.operand;
        self.isPending=NO;
    }else if([@"m+" isEqual:operation]){
        self.storedValue = self.storedValue + self.operand;
        self.isPending=NO;
    }else if([@"mr" isEqual:operation]){
        self.operand = self.storedValue;
        self.isPending=NO;
    }else if([@"mc" isEqual:operation]){
        self.storedValue = 0;
        self.isPending=NO;
    }else if([@"1/x" isEqual:operation]){
        self.operand = 1/self.operand;
        self.isPending=NO;
    }else if([@"sin" isEqual:operation]){
        if(self.isDegrees){
            self.operand = self.operand * (M_PI/180.0);
       } 
        self.operand = sin(self.operand);
        self.isPending=NO;
    }else if([@"cos" isEqual:operation]){
        if(isDegrees){
            self.operand = self.operand * (M_PI/180.0);
        }
        self.operand = cos(self.operand);
        self.isPending=NO;
    }else if([@"C" isEqual:operation]){
        self.operand = 0;
        self.waitingOperand=0;
        waitingOperation=nil;
        self.storedValue=0;
        self.isPending=NO;
    }else{
        [self performWaitingOperation];
        waitingOperation = operation;
        self.waitingOperand = self.operand;
        self.isPending=YES;
    }
    return self.operand;
}


- (id)init
{
    self = [super init];
    if (self) {
    }
    
    return self;
}

@end
